
local MAJOR = "StarLibError-1.0" 
local MINOR = 1
assert(LibStub, MAJOR.." requires LibStub") 
local StarLibError = LibStub:NewLibrary(MAJOR, MINOR)
if not StarLibError then return end

if not StarLibError.__index then
	StarLibError.__index = StarLibError
	StarLibError.pool = setmetatable({}, {__mode = "k"})
	StarLibError.name = MAJOR
end

function StarLibError:New(name, handler) 
	if not name then
		self:Print("StarLibError:New(handler, name) received name == nil")
		return
	end
	if not name then 
		self:Print("You must provide StarLibError with a name")
		return
	end
	
	local obj = next(self.pool)

	if obj then
		self.pool[obj] = nil
	else
		obj = {}
	end

	setmetatable(obj, self)
	
	obj.name = name

	if not handler then
		obj.handler = self.Print
	else
		obj.handler = handler	
	end
	
	return obj	
end

function StarLibError:Del(ev)
	if self == StarLibError then
		LibProperty.pool[ev] = true
	else
		LibProperty.pool[self] = true
	end
end

function StarLibError.Print(self, text)
ChatFrame1:AddMessage("|hc:ffff0000|" .. self.name .. ": " .. text)
	assert(self, "StarLibError failed printing due to nil self")
	if not self.name then 
		ChatFrame1:AddMessage("StarLibError object has no name. Type of self " .. type(self))
		assert(self.name, "Check ChatFrame1")
		return
	end
	assert(text, "StarLibError failed printing due to nil text (" .. self.name .. ")")
	if type(self.handler) == "function" and self.hasExternalHandler then
		ChatFrame1:AddMessage("|hc:ffff0000|" .. self.name .. ": " .. text)
	end
end

StarLibError.handler = StarLibError.Print